#include "prjlibs-include/standards.h"
#include <unistd.h>
#include <errno.h>

#include "skalibs/include/stddjb.h"
#include "prjlibs-include/constants.h"
#include "runwhen.h"

extern char const* PROG;

void rw_pass(struct taia const* t, char** argv) {
  char buf[2*TAIN_PACK+1];

  buf[tain_fmt(buf, t)]='\0';

  if (argv[0]==null) {
    if (buffer_puts(buffer_1, buf)<0 ||
        buffer_putsflush(buffer_1, "\n")<0)
      strerr_die3sys(errstat, PROG, err_unable, "write to stdout: ");
    _exit(0);
  }

  if (pathexec_env(argv[0], buf)==0)
    strerr_die5sys(111, PROG, err_unable, err_setvar, argv[0], ": ");
  ++argv;
  pathexec((char const**)argv);
  strerr_die5sys(errstat, PROG, err_unable, err_exec, argv[0], ": ");
}
